diff --git a/.gitmodules b/.gitmodules
index ab767e8d785d00d7421f07223b66ec7392da55a4..dfebae57688a574e67c976eb24a7bc63f77a468f 100644
--- a/.gitmodules
+++ b/.gitmodules
@@ -57,3 +57,6 @@
 [submodule "zipr_install"]
 	path = zipr_install
 	url = git@git.zephyr-software.com:allnp/zipr_install.git
+[submodule "zipr_xeon_plugin"]
+	path = zipr_xeon_plugin
+	url = git@git.zephyr-software.com:allnp/xeon_plugin
diff --git a/build-all.sh b/build-all.sh
index 7beadcb085b837168336df3b5e3ea468eea83e44..f83a847dd998aca8940174718dec14b47cc4e5a4 100755
--- a/build-all.sh
+++ b/build-all.sh
@@ -115,6 +115,11 @@ if [ -d $ZIPR_SCFI_PLUGIN ]; then
 	scons  $SCONSDEBUG || exit 1
 fi
 
+if [ -d $ZIPR_XEON_PLUGIN ]; then
+        cd $ZIPR_XEON_PLUGIN
+        scons  $SCONSDEBUG || exit
+fi
+
 cd $PEASOUP_UMBRELLA_DIR/zipr_large_only_plugin/
 scons $SCONSDEBUG || exit 1
 
diff --git a/set_env_vars b/set_env_vars
index 0131d303fcfecc87c36f9476f46a633113a4e415..4335eb554ce12b28f431b53ac3898ce87a713bad 100644
--- a/set_env_vars
+++ b/set_env_vars
@@ -17,6 +17,7 @@ export ZIPR_INSTALL=$PEASOUP_UMBRELLA_DIR/zipr_install
 export ZIPR_CALLBACKS=$PEASOUP_UMBRELLA_DIR/zipr_callbacks
 export ZIPR_SDK=$PEASOUP_UMBRELLA_DIR/zipr_sdk
 export ZIPR_SCFI_PLUGIN=$PEASOUP_UMBRELLA_DIR/zipr_scfi_plugin
+export ZIPR_XEON_PLUGIN=$PEASOUP_UMBRELLA_DIR/zipr_xeon_plugin
 export SECURITY_TRANSFORMS_HOME=$PEASOUP_UMBRELLA_DIR/security_transforms
 export IRDB_TRANSFORMS=$PEASOUP_UMBRELLA_DIR/irdb_transforms
 export ZEST_RUNTIME=$PEASOUP_UMBRELLA_DIR/zest_runtime
diff --git a/zipr_xeon_plugin b/zipr_xeon_plugin
new file mode 160000
index 0000000000000000000000000000000000000000..e1cfb5c43da48c1bfade08f4e53ed7b29f59714f
--- /dev/null
+++ b/zipr_xeon_plugin
@@ -0,0 +1 @@
+Subproject commit e1cfb5c43da48c1bfade08f4e53ed7b29f59714f